using System;
using Server;

namespace Server.Items
{
	public class Statue2EAddon : BaseAddon
	{
		public override BaseAddonDeed Deed{ get{ return new Statue2EDeed(); } }

        public override bool RetainDeedHue { get { return true; } }

        [Constructable]
		public Statue2EAddon() : this( 0 )
		{
		}

		[Constructable]
		public Statue2EAddon( int hue )
		{
			AddComponent( new AddonComponent( 0x139E ), 0, 0, 0 );
            AddComponent( new AddonComponent( 0x139F ), -1, 0, 0);
            AddComponent( new AddonComponent( 0x13A0 ), 0, -1, 0);
            Hue = hue;
			
		}

		public Statue2EAddon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 1 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class Statue2EDeed : BaseAddonDeed
	{
		public override BaseAddon Addon{ get{ return new Statue2EAddon( this.Hue ); } }
		// public override int LabelNumber{ get{ return 1044328; } } // pentagram

		[Constructable]
		public Statue2EDeed()
		{
            Name = "Man Statue East";
		}

		public Statue2EDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}