using System;
using Server;

namespace Server.Items
{
	public class StatueEAddon : BaseAddon
	{
		public override BaseAddonDeed Deed{ get{ return new StatueEDeed(); } }

        public override bool RetainDeedHue { get { return true; } }

        [Constructable]
		public StatueEAddon() : this( 0 )
		{
		}

		[Constructable]
		public StatueEAddon( int hue )
		{
			AddComponent( new AddonComponent( 0x12D8 ), 0, 0, 0 );
            Hue = hue;
		}

		public StatueEAddon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 1 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class StatueEDeed : BaseAddonDeed
	{
		public override BaseAddon Addon{ get{ return new StatueEAddon( this.Hue ); } }
		// public override int LabelNumber{ get{ return 1044328; } } // pentagram

		[Constructable]
		public StatueEDeed()
		{
            Name = "Tall Statue East";
		}

		public StatueEDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}