using System;
using Server;

namespace Server.Items
{
	public class StatueSAddon : BaseAddon
	{
		public override BaseAddonDeed Deed{ get{ return new StatueSDeed(); } }

        public override bool RetainDeedHue { get { return true; } }

        [Constructable]
		public StatueSAddon() : this( 0 )
		{
		}

		[Constructable]
		public StatueSAddon( int hue )
		{
			AddComponent( new AddonComponent( 0x12D9 ), 0, 0, 0 );
            Hue = hue;
			
		}

		public StatueSAddon( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 1 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}

	public class StatueSDeed : BaseAddonDeed
	{
		public override BaseAddon Addon{ get{ return new StatueSAddon( this.Hue ); } }
		// public override int LabelNumber{ get{ return 1044328; } } // pentagram

		[Constructable]
		public StatueSDeed()
		{
            Name = "Tall Statue South";
		}

		public StatueSDeed( Serial serial ) : base( serial )
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}