using System;
using Server;
using Server.Engines.Craft;

namespace Server.Items
{
	[Flipable( 0x1EBA, 0x1EBB )]
	public class CrystalToolKit : BaseTool
	{
        public override CraftSystem CraftSystem { get { return DefCrystalCrafting.CraftSystem; } }

		[Constructable]
		public CrystalToolKit() : base( 0x1EBA )
		{
            Name = "Crystal Crafting Tool Kit";
            Hue = 1257;
			Weight = 2.0;
		}

		[Constructable]
		public CrystalToolKit( int uses ) : base( uses, 0x1EBA )
		{
			Weight = 2.0;
		}

        public CrystalToolKit(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}