using System;
using Server.Items;

namespace Server.Items
{
    [Flipable(0x1947, 0x1948)]
	public class PowderStoneVeramide : Item
	{
		private int m_Exchange = 1000;
		private int m_Amountof = 25;

		[CommandProperty( AccessLevel.GameMaster )]
		public int Exchange
		{
			get
			{
				return m_Exchange;
			}
			set
			{
				m_Exchange = value;
				InvalidateProperties();
			}
		}

		[CommandProperty( AccessLevel.GameMaster )]
		public int Amountof
		{
			get
			{
				return m_Amountof;
			}
			set
			{
				m_Amountof = value;
				InvalidateProperties();
			}
		}
		[Constructable]
		public PowderStoneVeramide() : base( 0x1947 )
		{
			Movable = false;
            Hue = 0x11C;
            Name = "Veramide Powder Stone";
		}

		public override void GetProperties( ObjectPropertyList list )
		{
			base.GetProperties( list );
            list.Add("Rate: {0}gp For: {1} Veramide Powder.", m_Exchange, m_Amountof);
		}

		public override void OnSingleClick( Mobile from )
		{
			base.OnSingleClick( from );
			base.LabelTo( from, "Exchange Rate: {0}gp", m_Exchange );
		}

		public override void OnDoubleClick( Mobile from )
		{
			Container pack = from.Backpack;
			if ( pack != null && pack.ConsumeTotal( typeof( Gold ), m_Exchange ) )
			{
				{
					from.SendMessage( 0x35, "You Get The Powder" );
                    from.AddToBackpack(new VeramidePowder(m_Amountof));
				}
			}
			else
			{
				from.SendMessage( 0x91, "You need at least the going rate in your backpack to use this." );
			}
		}

        public PowderStoneVeramide(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 ); // version
			writer.Write( (int) m_Exchange );
			writer.Write( (int) m_Amountof );
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
			switch ( version )
			{
				case 0:
				{
					m_Exchange = reader.ReadInt();
					m_Amountof = reader.ReadInt();
					break;
				}
			}
		}
	}
}