using System;
using Server;
using Server.Engines.Craft;

namespace Server.Items
{
	public class PowderToolKit : BaseTool
	{
        public override CraftSystem CraftSystem { get { return DefPowderCrafting.CraftSystem; } }

		[Constructable]
		public PowderToolKit() : base( 0x1C13 )
		{
            Name = "A Powder Crafting Manual";
            Hue = 2101;
			Weight = 2.0;
		}

		[Constructable]
		public PowderToolKit( int uses ) : base( uses, 0x1C13 )
		{
			Weight = 2.0;
		}

        public PowderToolKit(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );

			writer.Write( (int) 0 ); // version
		}

		public override void Deserialize( GenericReader reader )
		{
			base.Deserialize( reader );

			int version = reader.ReadInt();
		}
	}
}