/***************************************************************************/
/*			ResourceBox.cs | ResourceBoxGump.cs | StorageTypes.cs          */
/*							Created by A_Li_N   Edited my Vertigo          */
/*				Credits :                                                  */
/*						Original Gump Layout - Lysdexic                    */
/*						Hashtable help - UOT and daat99                    */
/***************************************************************************/
/*	Addition of different Resources :                                      */
/*		To add/remove resource types from the box, simply put the Type of  */
/*		the resource in the catagory you wish it to be in.  Each catagory  */
/*		can hold up to 32 entries without messing a LOT with the gump.     */
/*	Removing of Resources :                                                */
/*		Commenting out or deleting the type you wish to remove will remove */
/*		the type AND the amount each Resource Box contains.                */
/***************************************************************************/

using System;

namespace Server.Items
{
	public class StorageTypes
	{
		private static Type[] m_Logs = new Type[]
		{
			typeof( Log ),
            typeof( OakLog ),
			typeof( AshLog ),
			typeof( YewLog ),
			typeof( HeartWoodLog ),
			typeof( BloodWoodLog ),
     		typeof( FrostWoodLog ),
		};
		public static Type[] Logs{ get{ return m_Logs; } }

		private static Type[] m_Boards = new Type[]
		{
			typeof( Board ),
            typeof( OakBoard ),
			typeof( AshBoard ),
			typeof( YewBoard ),
			typeof( HeartWoodBoard ),
            typeof( BloodWoodBoard ),
			typeof( FrostWoodBoard ),
		};
		public static Type[] Boards{ get{ return m_Boards; } }

		private static Type[] m_Ingots = new Type[]
		{
			typeof( IronIngot ),
			typeof( DullCopperIngot ),
			typeof( ShadowIronIngot ),
			typeof( CopperIngot ),
			typeof( BronzeIngot ),
			typeof( GoldIngot ),
            typeof( SilverIngot ),
            typeof( AgapiteIngot ),
			typeof( VeriteIngot ),
			typeof( ValoriteIngot ),
            typeof( UridiumIngot ),
            typeof( TrilliumIngot ),
            typeof( TitaniumIngot ),
            typeof( PlatinumIngot ),
            typeof( ZeniteIngot ),
            typeof( NaquiniteIngot ),
            typeof( GalviniteIngot ),
            typeof( TrilamideIngot ),
            typeof( VeramideIngot ),
            typeof( ZenlamideIngot ),
		};
		public static Type[] Ingots{ get{ return m_Ingots; } }

		private static Type[] m_Granites = new Type[]
		{
			typeof( Granite ),
			typeof( DullCopperGranite ),
			typeof( ShadowIronGranite ),
			typeof( CopperGranite ),
			typeof( BronzeGranite ),
            typeof( GoldGranite ),
			typeof( SilverGranite ),
            typeof( AgapiteGranite ),
			typeof( VeriteGranite ),
			typeof( ValoriteGranite ),
            typeof( UridiumGranite ),
            typeof( TrilliumGranite ),
            typeof( TitaniumGranite ),
            typeof( PlatinumGranite ),
            typeof( ZeniteGranite ),
            typeof( NaquiniteGranite ),
            typeof( GalviniteGranite ),
            typeof( TrilamideGranite ),
            typeof( VeramideGranite ),
            typeof( ZenlamideGranite ),
		};
		public static Type[] Granites{ get{ return m_Granites; } }

		private static Type[] m_Scales = new Type[]
		{
			typeof( RedScales ),
			typeof( YellowScales ),
			typeof( BlackScales ),
			typeof( GreenScales ),
			typeof( WhiteScales ),
			typeof( BlueScales ),
		};
		public static Type[] Scales{ get{ return m_Scales; } }

		private static Type[] m_Leathers = new Type[]
		{
			typeof( Leather ),
			typeof( SpinedLeather ),
			typeof( HornedLeather ),
			typeof( BarbedLeather ),
			typeof( RibbedLeather ),
			typeof( DreadLeather ),
			typeof( EtheralLeather ),
		};
		public static Type[] Leathers{ get{ return m_Leathers; } }

        private static Type[] m_Crystals = new Type[]
		{
            typeof( Crystal ),
            typeof( AmazoniteCrystal ),
            typeof( AmberCrystal ),
            typeof( AmethystCrystal ),
            typeof( AragoniteCrystal ),
            typeof( BixbiteCrystal ),
            typeof( BloodStoneCrystal ),
            typeof( CalciteCrystal ),
            typeof( GoldStoneCrystal ),
            typeof( LabradoriteCrystal ),
            typeof( MoldaviteCrystal ),
            typeof( MorganiteCrystal ),
            typeof( QuartzCrystal ),
            typeof( RhodoniteCrystal ),
            typeof( RubyCrystal ),
            typeof( SapphireCrystal ),
            typeof( SugiliteCrystal ),
            typeof( TanzaniteCrystal ),
            typeof( TurquoiseCrystal ),
            typeof( VarisiteCrystal ),
		};
        public static Type[] Crystals { get { return m_Crystals; } }

        private static Type[] m_Powders = new Type[]
		{
            typeof( Powder ),
            typeof( IronPowder ),
            typeof( DullCopperPowder ),
            typeof( ShadowIronPowder ),	
            typeof( CopperPowder ),		
            typeof( BronzePowder ),		
            typeof( GoldPowder ),		
            typeof( SilverPowder ),   
            typeof( AgapitePowder ),		
            typeof( VeritePowder ),		
            typeof( ValoritePowder ),	
            typeof( UridiumPowder ),	    
            typeof( TrilliumPowder ),
            typeof( TitaniumPowder ),    
            typeof( PlatinumPowder ),  
            typeof( ZenitePowder ),
            typeof( NaquinitePowder ),   
            typeof( GalvinitePowder ),   
            typeof( TrilamidePowder ), 
            typeof( VeramidePowder ),  
            typeof( ZenlamidePowder ),
            typeof( EtheralPowder ),
		};
        public static Type[] Powders { get { return m_Powders; } }

		private static Type[] m_Misc = new Type[]
		{
            typeof( Sand ),
			typeof( Cloth ),
			typeof( Cotton ),
			typeof( Flax ),
			typeof( Wool ),
			typeof( Bandage ),
			typeof( Arrow ),
			typeof( Bolt ),
			typeof( Feather ),
			typeof( Shaft ),
		};
		public static Type[] Misc{ get{ return m_Misc; } }

		private static Type[] m_Reagents = new Type[]
		{
			typeof( BlackPearl ),
			typeof( Bloodmoss ),
			typeof( Garlic ),
			typeof( Ginseng ),
			typeof( MandrakeRoot ),
			typeof( Nightshade ),
			typeof( SulfurousAsh ),
			typeof( SpidersSilk ),
			typeof( BatWing ),
			typeof( GraveDust ),
			typeof( DaemonBlood ),
			typeof( NoxCrystal ),
			typeof( PigIron ),
		};
		public static Type[] Reagents{ get{ return m_Reagents; } }
	}
}