using System;
using Server;

namespace Server.Items
{
    public class YaksCrystalForkOfTheGods : WarFork
	{
        public override WeaponAbility PrimaryAbility { get { return WeaponAbility.BleedAttack; } }
        public override WeaponAbility SecondaryAbility { get { return WeaponAbility.Disarm; } }

        public override WeaponAnimation DefAnimation { get { return WeaponAnimation.Pierce1H; } }

		public override int ArtifactRarity{ get{ return 15; } }

		public override int InitMinHits{ get{ return 155; } }
		public override int InitMaxHits{ get{ return 255; } }

		[Constructable]
		public YaksCrystalForkOfTheGods()
		{
            Name = "Fork Of The Gods";

            ItemID = 0x1405;

            WeaponAttributes.UseBestSkill = 1;
            WeaponAttributes.HitLightning = 85;
			WeaponAttributes.HitPoisonArea = 30;
			WeaponAttributes.ResistPoisonBonus = 20;

            Attributes.SpellChanneling = 1; // true/false value
			Attributes.AttackChance = 15;
			Attributes.WeaponDamage = 50;
		}

		public override void GetDamageTypes( Mobile wielder, out int phys, out int fire, out int cold, out int pois, out int nrgy )
		{
            fire = 50;
            cold = 00;
            nrgy = 50;
			phys = 25;
			pois = 0;
		}

        public YaksCrystalForkOfTheGods(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}
		
		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();

            if (ItemID == 0x1405)
                ItemID = 0x1405;
		}
	}
}