using System;
using Server;

namespace Server.Items
{
	public class YaksCrystalMace : Kryss
	{
		public override int ArtifactRarity{ get{ return 12; } }

		public override int InitMinHits{ get{ return 255; } }
		public override int InitMaxHits{ get{ return 255; } }

		[Constructable]
		public YaksCrystalMace()
		{
            Name = "Mace";

			ItemID = 0x2D30;

            WeaponAttributes.UseBestSkill = 1;
			WeaponAttributes.HitPoisonArea = 100;
			WeaponAttributes.ResistPoisonBonus = 20;

            Attributes.SpellChanneling = 1; // true/false value
			Attributes.AttackChance = 15;
			Attributes.WeaponDamage = 50;
		}

		public override void GetDamageTypes( Mobile wielder, out int phys, out int fire, out int cold, out int pois, out int nrgy )
		{
			fire = cold = nrgy = 75;
			phys = 25;
			pois = 0;
		}

        public YaksCrystalMace(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}
		
		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();

			if ( ItemID == 0x1401 )
                ItemID = 0x2D30;
		}
	}
}