using System;
using Server;

namespace Server.Items
{
    [FlipableAttribute(0x2D20, 0x2D2C)]
	public class YaksCrystalSpellBlade : Kryss
	{
		public override int ArtifactRarity{ get{ return 7; } }

		public override int InitMinHits{ get{ return 100; } }
		public override int InitMaxHits{ get{ return 255; } }

		[Constructable]
		public YaksCrystalSpellBlade()
		{
            Name = "Spell Blade";

            ItemID = 0x2D20;

			WeaponAttributes.UseBestSkill = 1;
			// WeaponAttributes.ResistPoisonBonus = 20;

            Attributes.SpellChanneling = 1; // true/false value
			Attributes.RegenMana = 40;
			Attributes.WeaponDamage = 50;
		}

        public YaksCrystalSpellBlade(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}
		
		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}