using System;
using Server;

namespace Server.Items
{
    [FlipableAttribute(0x2D2D, 0x2D21)]
	public class YaksCrystalSplinter : Kryss
	{
		public override int ArtifactRarity{ get{ return 5; } }

		public override int InitMinHits{ get{ return 100; } }
		public override int InitMaxHits{ get{ return 125; } }

		[Constructable]
		public YaksCrystalSplinter()
		{
            Name = "Crystal Splinter";

            ItemID = 0x2D2D;

            WeaponAttributes.UseBestSkill = 1;
			// WeaponAttributes.HitPoisonArea = 100;
			// WeaponAttributes.ResistPoisonBonus = 20;

            Attributes.BonusDex = 45;
            Attributes.SpellChanneling = 1; // true/false value
			// Attributes.RegenMana = 40;
			Attributes.WeaponDamage = 30;
            Attributes.WeaponSpeed = 70;
		}

        public YaksCrystalSplinter(Serial serial) : base(serial)
		{
		}

		public override void Serialize( GenericWriter writer )
		{
			base.Serialize( writer );
			writer.Write( (int) 0 );
		}
		
		public override void Deserialize(GenericReader reader)
		{
			base.Deserialize( reader );
			int version = reader.ReadInt();
		}
	}
}